#include "node.h"
#include <cstdlib>
#include <iostream>

node::node(link_t& head_ptr, value_t entry){
    data = entry;
    next = head_ptr;                   
}

void list_head_insert(node::link_t& head_ptr, node::value_t entry){
     node::link_t temp = new node(head_ptr, entry);
     head_ptr = temp;
}

void list_insert(node::link_t& prev_ptr, node::value_t entry){
    if (prev_ptr != NULL){
        node::link_t temp = new node(prev_ptr->next, entry);
        prev_ptr->next = temp;
    }
}

void list_head_remove(node::link_t& head_ptr){
    node::link_t temp = head_ptr;
    head_ptr = head_ptr->next;
    delete temp;
}

void list_remove(node::link_t& prev_ptr){
    node::link_t temp = prev_ptr->next;
    prev_ptr->next = temp->next;
    delete temp;
}

void list_clear(node::link_t& head_ptr){
     while(head_ptr != NULL)
         list_head_remove(head_ptr);
}

int list_length(node::link_t head_ptr){
    int counter = 0;
    
    node::link_t cursor = head_ptr;
    while(cursor != NULL){
        counter = counter + 1;
        cursor = cursor->next;
    }
    
    return counter;
}

void list_print_all(node::link_t head_ptr){
    node::link_t cursor = head_ptr;
    std::cout << "Listenin Elemanlari: ";
    while(cursor != NULL){
        std::cout << cursor->data << ", ";
        cursor = cursor->next;
    }
    std::cout << std::endl;
}

node::link_t list_search(node::link_t head_ptr, node::value_t target){
    node::link_t cursor = head_ptr;
    while(cursor != NULL){
        if (cursor->data == target)
            return cursor;
        cursor = cursor->next;
    }
    
    return NULL;
}

node::link_t list_locate(node::link_t head_ptr, int position){
    node::link_t cursor = head_ptr;
    int i = 1;
    while(cursor != NULL && i < position){
        cursor = cursor->next;
        i = i + 1;
    }
    
    return cursor;
}
